//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "main.h"
#include "about.h"
#include "tileunit.h"
#include "util.h"
#include "xFiles.hpp"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::mnuExitClick(TObject *Sender)
{
  Close();        
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuAboutClick(TObject *Sender)
{
  TAboutBox* box = new TAboutBox(this);
  try {
    box->ShowModal();
  } __finally {
    delete box;
  }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuNewClick(TObject *Sender)
{
  TTiles::Instance().FreeTiles(); // sϮw
  FFileName = "";
  FFirstNo = -1;
  tvwTiles->Items->Clear();

  UpdateControlStatus();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuOpenClick(TObject *Sender)
{
  if (dlgOpen->Execute()) // }ɹܲ
    try {
      mnuNewClick(NULL); // Ϯwe

      // JϮw
      TTiles::Instance().LoadFromFile(dlgOpen->FileName);
      // ŪϤsմyz
      ReadComponentResFile(ChangeFileExt(dlgOpen->FileName, ".TVW"), tvwTiles);

      FFileName = dlgOpen->FileName; // ŪaιϮw\

     // Yܥs, hLܲĤ@Ӹ`I
      if (!tvwTiles->Selected)
        tvwTiles->Selected = tvwTiles->Items->GetFirstNode();
    } __finally {
      UpdateControlStatus();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::mnuSaveClick(TObject *Sender)
{
  // YO"tss" ٥wɦW, NݨϥΪɦW
  if (dynamic_cast<TComponent*>(Sender)->Tag == 1 || FFileName == "") {
    dlgSave->Filter = dlgOpen->Filter;
    // ߰ݨϥΪɦW, YN}
    if (!dlgSave->Execute()) return;
    FFileName = dlgSave->FileName; // NɦWO_
  }

  BackupAttr(grdTile->Col, grdTile->Row); // xsثeϤݩ

  TTiles::Instance().SaveToFile(FFileName); // xsϮw
  // xsϤsմyz
  WriteComponentResFile(ChangeFileExt(FFileName, ".TVW"), tvwTiles);
  UpdateControlStatus(); // sD
}
//---------------------------------------------------------------------------


void __fastcall TMainForm::mnuRemoveClick(TObject *Sender)
{
  if (!tvwTiles->Selected) return; // @wnwYӸsդ~

  // oثeϤsխiϤs
  int No = (int)tvwTiles->Selected->Data;

  TTiles& Tiles = TTiles::Instance();
  // NӹϤsժϤ]"m"
  for (int i = 0; i < Tiles.Tile[No].XNum *Tiles.Tile[No].YNum; i++)
    Tiles.Tile[No + i].Disposed = true;

  tvwTiles->Selected->Delete(); // NϤsմyz屼
  UpdateControlStatus();
}
//---------------------------------------------------------------------------

#define MIN(a,b) ((a)<(b)?(a):(b))

void __fastcall TMainForm::AddTreeNode(AnsiString FileName, int FirstNo)
{
  // b˵󤤥[JϤsժ`I]yz^
  // Ϥsմyzw]Ȭ[J BMP ϧɦW
  TTreeNode* node = tvwTiles->Items->Add(NULL, ExtractFileNameNoExt(FileName));
  node->Data = (void*)FirstNo;  // OsչĤ@iϤs

  // Yܥs, hLܲĤ@Ӹ`I
  if (tvwTiles->Selected == NULL)
    tvwTiles->Selected = tvwTiles->Items->GetFirstNode();
}

void __fastcall TMainForm::mnuAddClick(TObject *Sender)
{
  if (dlgOpenPicture->Execute()) {

    Graphics::TBitmap* Bits = new Graphics::TBitmap; // ͤθJ[JϮw bitmap
    
    try {
      Bits->LoadFromFile(dlgOpenPicture->FileName);

      // Y bitmap iϤؤo٤p, LkBz
      if (Bits->Width < TILE_WIDTH || Bits->Height < TILE_HEIGHT)
        throw Exception("Bitmap is too small");

      // ̤jO 5 x 5 Ϥs
      // ϧΤΫ᪺babϤƥ
      int XNum = MIN(5, Bits->Width / TILE_WIDTH);
      int YNum = MIN(5, Bits->Height / TILE_HEIGHT);

      int FirstNo;
      // ̧ǤΥX XNum * YNum ӹϤ
      for (int y = 0; y < YNum; y++)
        for (int x = 0; x < XNum; x++) {
          TTile* Tile = new TTile;  // ͹Ϥ
          
          // NϧνƻsϤ bitmap W
          Tile->Bitmap->Canvas->CopyRect(TILE_RECT, Bits->Canvas,
            Rect(x * TILE_WIDTH, y * TILE_HEIGHT,
            (x + 1) * TILE_WIDTH, (y + 1) * TILE_HEIGHT));

          Tile->FirstTile = (x == 0 && y == 0); // OOsYY
          Tile->XNum = XNum;  // OsYY, tdO
          Tile->YNum = YNum;  // ϤsժbabϤƥ

          // NͪsϤ[JϮw
          if (Tile->FirstTile)
            FirstNo = TTiles::Instance().AddTile(Tile); // osժYYs
          else
            TTiles::Instance().AddTile(Tile);
        }

      // Nsմyz[J˵
      AddTreeNode(dlgOpenPicture->FileName, FirstNo);

      UpdateControlStatus();
    } __finally {
      delete Bits;  // lvSΤF, 
    }
  }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::BackupAttr(int Col, int Row)
{
  if (FFirstNo == -1) return;

  int No = FFirstNo + Row * grdTile->ColCount + Col; // p쥻ܪϤs

  // NϥΪ̳]wϤݩʼg^h
  TTileAttr attr = TTileAttr();

  // iHVa
  if (cbxCanPass->Checked) attr = attr << taCanPass;
  if (cbxBulletCanPass->Checked) attr = attr << taBulletCanPass;
  if (cbxCanBreak->Checked) attr = attr << taCanBreak;
  if (cbxFlag->Checked) attr = attr << taFlag;

  TTiles::Instance().Tile[No].Attr = attr;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::UpdateControlStatus()
{
  Caption = Format("%s - %s", OPENARRAY(TVarRec,
    (Application->Title, FFileName == "" ? AnsiString("Untitled") : FFileName)));

  stbMain->SimpleText = Format("Ϥ`: %d", OPENARRAY(TVarRec, (TTiles::Instance().TileNum)));

  mnuSave->Enabled = TTiles::Instance().TileNum != 0;
  mnuSaveAs->Enabled = TTiles::Instance().TileNum != 0;

  grdTile->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::grdTileDrawCell(TObject *Sender, int ACol,
      int ARow, TRect &Rect, TGridDrawState State)
{
  if (!tvwTiles->Selected) return; // @wnܬYsդ~

  // ҹϤs = iϤs + ARow * bƥ + ACol
  int No = (int)tvwTiles->Selected->Data + ARow * grdTile->ColCount + ACol;
  if (No >= TTiles::Instance().TileNum) return; // O_Xks ?

  // eXϤ
  grdTile->Canvas->Draw(Rect.Left, Rect.Top, TTiles::Instance().Tile[No].Bitmap);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::grdTileSelectCell(TObject *Sender, int ACol,
      int ARow, bool &CanSelect)
{
  BackupAttr(grdTile->Col, grdTile->Row);
  RestoreAttr(ACol, ARow);

  lblTileNo->Caption = Format("s: %d (%d - %d)",
    OPENARRAY(TVarRec, (FFirstNo, FFirstNo,
    FFirstNo + TTiles::Instance().Tile[FFirstNo].XNum * TTiles::Instance().Tile[FFirstNo].YNum - 1)));
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvwTilesChange(TObject *Sender, TTreeNode *Node)
{
  if (!tvwTiles->Selected) return;

  // x^ثe
  BackupAttr(grdTile->Col, grdTile->Row);

  int No = (int)tvwTiles->Selected->Data;
  if (No < TTiles::Instance().TileNum) {
    grdTile->ColCount = TTiles::Instance().Tile[No].XNum;
    grdTile->RowCount = TTiles::Instance().Tile[No].YNum;

    grdTile->Row = 0;
    grdTile->Col = 0;

    FFirstNo = No;
    lblDimension->Caption = Format("jp: %d x %d",
      OPENARRAY(TVarRec, (TTiles::Instance().Tile[FFirstNo].XNum,
      TTiles::Instance().Tile[FFirstNo].YNum)));
    lblTileNo->Caption = Format("s: %d ~ %d",
      OPENARRAY(TVarRec, (No, No + TTiles::Instance().Tile[No].XNum * TTiles::Instance().Tile[No].YNum - 1)));

    RestoreAttr(0, 0);
  }

  UpdateControlStatus();        
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::RestoreAttr(int Col, int Row)
{
  if (FFirstNo == -1) return;

  int No = FFirstNo + Row * grdTile->ColCount + Col; // pYNܪϤs

  TTiles& Tiles = TTiles::Instance();

  // NҿܪϤݩʥ checkbox {X
  cbxCanPass->Checked = Tiles.Tile[No].Attr.Contains(taCanPass);
  cbxBulletCanPass->Checked = Tiles.Tile[No].Attr.Contains(taBulletCanPass);
  cbxCanBreak->Checked = Tiles.Tile[No].Attr.Contains(taCanBreak);
  cbxFlag->Checked = Tiles.Tile[No].Attr.Contains(taFlag);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  util_init();
  
  mnuNewClick(NULL);
}
//---------------------------------------------------------------------------

