//---------------------------------------------------------------------------

#ifndef tileunitH
#define tileunitH

#include <vector>

#undef VAR
#undef INI

#ifdef tileunitCPP
#define VAR
#define INI(x) = x
#else
#define VAR extern
#define INI(x)
#endif

//---------------------------------------------------------------------------
// Ϥݩ: iHqL, ϤiQ}, luiHqL, ϤOxX
enum TTileAttrElement {taCanPass, taCanBreak, taBulletCanPass, taFlag};
typedef Set<TTileAttrElement, taCanPass, taFlag> TTileAttr;

class TTile { // @Ϥ
private:
  Graphics::TBitmap* FBits; // sϤ bitmap
  TTileAttr FAttr; // ݩ
  bool FDisposed; // O_wm

  bool FFirstTile; // OOϤsո̪Ĥ@iϤ
  Byte FXNum, FYNum; // ϤsժVaVϤƥ
protected:
public:
  TTile();
  ~TTile();

  void init();

  // assignment constructor
  TTile& operator=(const TTile& t);
  // copy constructor
  TTile(const TTile& t);

  // JxsϤ
  void LoadFromStream(TStream* Stream);
  void SaveToStream(TStream* Stream);

  // ѵ~ɦsݩ
  __property Graphics::TBitmap* Bitmap = {read = FBits};
  __property TTileAttr Attr = {read = FAttr, write = FAttr};
  __property bool Disposed = {read = FDisposed, write = FDisposed};

  __property bool FirstTile = {read = FFirstTile, write = FFirstTile};
  __property Byte XNum = {read = FXNum,  write = FXNum};
  __property Byte YNum = {read = FYNum,  write = FYNum};
};

class TTiles { // Ϯw
// Singleton Pattern
private:
  static TTiles* FInstance;
public:
  static TTiles& Instance();  
private:
  typedef std::vector<TTile*> TTileArray;
  TTileArray* FTiles; // Ҿ֦Ϥ}C

  int GetTileNum(); // Ϥƥ

  TTile& GetTile(int No); // QίިoϤ
protected:
  TTiles();
  ~TTiles();
public:
  int AddTile(TTile* NewTile); // [JsϤ
  void FreeTiles(); // ҦϤ

  // JxsϮw
  void LoadFromFile(AnsiString FileName);
  void SaveToFile(AnsiString FileName);

  __property int TileNum = {read = GetTileNum};
  __property TTile Tile[int No] = {read = GetTile};
};

#endif
